#ifndef SIMPLEEXAMPLE_H
#define SIMPLEEXAMPLE_H

#include <QObject>
#include <QWidget>
#include <QLabel>
#include "PluginServices.h"
#include "TabInterface.h"
#include "CubePlugin.h"

class SimpleExample : public QObject, public cubepluginapi::CubePlugin, public cubepluginapi::TabInterface
{
    Q_OBJECT
    Q_INTERFACES(cubepluginapi::CubePlugin)
    Q_PLUGIN_METADATA(IID "SimpleExamplePlugin") // Unique plugin identifier

public:
    SimpleExample();

    // CubePlugin implementation
    virtual bool cubeOpened(cubepluginapi::PluginServices* service);
    virtual void cubeClosed();
    virtual QString name() const;
    virtual void version(int& major, int& minor, int& bugfix) const;
    virtual QString getHelpText() const;

    // TabInterface implementation
    virtual QString label() const;
    virtual QWidget* widget();

private slots:
    void treeItemIsSelected(cubepluginapi::TreeItem* item);

private:
    QWidget* widget_;
    QLabel* qlabel_;
    cubepluginapi::PluginServices* service_;
};

#endif // SIMPLEEXAMPLE_H
